/* Date:        August 21, 2013
 * Template:	MapperSecurityDecoratorGen.java.ftl
 * generator:   org.molgenis.generators.db.MapperSecurityDecoratorGen 4.0.0-testing
 */

package org.molgenis.omx.observ.value.db;

import java.util.List;

import java.text.ParseException;
import org.molgenis.framework.db.DatabaseAccessException;
import org.molgenis.framework.db.DatabaseException;
import org.molgenis.framework.db.Mapper;
import org.molgenis.framework.db.MapperDecorator;
import org.molgenis.framework.db.QueryRule;
import org.molgenis.framework.security.SimpleLogin;
import org.molgenis.io.TupleReader;
import org.molgenis.io.TupleWriter;

/**
 * TODO add column level security filters
 */
public class TextValueSecurityDecorator<E extends org.molgenis.omx.observ.value.TextValue> extends MapperDecorator<E>
{
	public TextValueSecurityDecorator(Mapper<E> generatedMapper)
	{
		super(generatedMapper);
	}

	@Override
	public int add(List<E> entities) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");
		}
		return super.add(entities);
	}

	@Override
	public int update(List<E> entities) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");

		}
		return super.update(entities);
	}

	@Override
	public int remove(List<E> entities) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");
				
		}
		return super.remove(entities);
	}

	@Override
	public int add(TupleReader reader, TupleWriter writer) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");
		}
		return super.add(reader, writer);
	}

	@Override
	public int count(QueryRule... rules) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canRead(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No read permission on org.molgenis.omx.observ.value.TextValue");

		}
		return super.count(rules);
	}

	@Override
	public List<E> find(QueryRule ...rules) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canRead(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No read permission on org.molgenis.omx.observ.value.TextValue");

		}

		List<E> result = super.find(rules);
		return result;
	}

	@Override
	public void find(TupleWriter writer, QueryRule ...rules) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canRead(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No read permission on org.molgenis.omx.observ.value.TextValue");

		}

		super.find(writer, rules);
	}

	@Override
	public E findById(Object id) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canRead(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No read permission on org.molgenis.omx.observ.value.TextValue");
		}
		
		return super.findById(id);
	}
	
	@Override
	public int remove(TupleReader reader) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");

			//TODO: Add row level security filters
		}
		return super.remove(reader);
	}

	@Override
	public int update(TupleReader reader) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");

			//TODO: Add row level security filters
		}
		return super.update(reader);
	}

	@Override
	public void find(TupleWriter writer, List<String> fieldsToExport, QueryRule[] rules) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canRead(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No read permission on org.molgenis.omx.observ.value.TextValue");

		}

		super.find(writer, fieldsToExport, rules);
	}

	@Override
	public int executeAdd(List<? extends E> entities) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");
		}
		return super.executeAdd(entities);
	}
	
	@Override
	public int executeUpdate(List<? extends E> entities) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");
		}
		return super.executeUpdate(entities);
	}
	
	@Override
	public int executeRemove(List<? extends E> entities) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");
		}
		return super.executeRemove(entities);
	}
	
	@Override
	public void resolveForeignKeys(List<E> entities) throws ParseException, DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
					throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");
		}
		super.resolveForeignKeys(entities);
	}
	
	@Override
	public List<E> toList(TupleReader reader, int limit) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canWrite(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No write permission on org.molgenis.omx.observ.value.TextValue");

			//TODO: Add row level security filters
		}
		return super.toList(reader, limit);
	}
	
	@Override
	public String createFindSqlInclRules(QueryRule[] rules) throws DatabaseException
	{
		if (this.getDatabase().getLogin() != null && !(this.getDatabase().getLogin() instanceof SimpleLogin))
		{
			if (!this.getDatabase().getLogin().canRead(org.molgenis.omx.observ.value.TextValue.class))
				throw new DatabaseAccessException("No read permission on org.molgenis.omx.observ.value.TextValue");
		}
		
		return super.createFindSqlInclRules(rules);
	}

	
	
}